@if exp="typeof(global.rain_object) == 'undefined'"
@iscript

/*
	Jӂ点vOC
*/

class RainGrain
{
	// J̃NX

	var fore; // \ʂ̉JIuWFNg
	var back; // ʂ̉JIuWFNg
	var xvelo; // x
	var yvelo; // cx
	var l, t; // ʒuƏcʒu
	var ownwer; // ̃IuWFNgL RainPlugin IuWFNg
	var spawned = false; // JoĂ邩
	var window; // EBhEIuWFNgւ̎Q

	function RainGrain(window, n, owner)
	{
		// RainGrain RXgN^
		this.owner = owner;
		this.window = window;

		fore = new Layer(window, window.fore.base);
		back = new Layer(window, window.back.base);

		fore.absolute = 2000000-1; // dˍ킹̓bZ[W
		back.absolute = fore.absolute;

		fore.hitType = htMask;
		fore.hitThreshold = 256; // }EXbZ[W͑S擧
		back.hitType = htMask;
		back.hitThreshold = 256;

		fore.loadImages("rain_0" + "_" + intrandom(0, 3)); // 摜ǂݍ
		back.assignImages(fore);
		var h = int(fore.imageHeight * (1.0 - n * 0.1));
		fore.setSizeToImageSize(); // C̃TCY摜̃TCYƓ
		back.setSizeToImageSize();
		fore.height = h;
		fore.imageTop = -(fore.imageHeight - h);
		back.height = h;
		back.imageTop = -(fore.imageHeight - h);
		var opa = 255 - n * 20;
		fore.opacity = opa;
		back.opacity = opa;
		xvelo = 0; //Math.random() - 0.5; // x
		yvelo = (5 - n) * 30 + 75 + Math.random() * 15; // cx
	}

	function finalize()
	{
		invalidate fore;
		invalidate back;
	}

	function spawn()
	{
		// o
		l = Math.random() * window.primaryLayer.width; // ʒu
		t = -fore.height; // cʒu
		spawned = true;
		fore.setPos(l, t);
		back.setPos(l, t); // ʂ̈ʒu
		fore.visible = owner.foreVisible;
		back.visible = owner.backVisible;
	}

	function resetVisibleState()
	{
		// \E\̏ԂĐݒ肷
		if(spawned)
		{
			fore.visible = owner.foreVisible;
			back.visible = owner.backVisible;
		}
		else
		{
			fore.visible = false;
			back.visible = false;
		}
	}

	function move()
	{
		// J𓮂
		if(!spawned)
		{
			// oĂȂ̂ŏo@
			if(Math.random() < 0.002) spawn();
		}
		else
		{
			l += xvelo;
			t += yvelo;
			if(t >= window.primaryLayer.height)
			{
				t = -int(fore.height * Math.random());
				l = Math.random() * window.primaryLayer.width;
			}
			fore.setPos(l, t);
			back.setPos(l, t); // ʂ̈ʒu
		}
	}

	function exchangeForeBack()
	{
		// \Ɨ̊Ǘ
		var tmp = fore;
		fore = back;
		back = tmp;
	}
}

class RainPlugin extends KAGPlugin
{
	// JU炷vOCNX

	var rains = []; // J
	var timer; // ^C}
	var window; // EBhEւ̎Q
	var foreVisible = true; // \ʂ\Ԃǂ
	var backVisible = true; // ʂ\Ԃǂ

	function RainPlugin(window)
	{
		super.KAGPlugin();
		this.window = window;
	}

	function finalize()
	{
		// finalize \bh
		// ̃NX̊Ǘ邷ׂẴIuWFNg𖾎Iɔj
		for(var i = 0; i < rains.count; i++)
			invalidate rains[i];
		invalidate rains;

		invalidate timer if timer !== void;

		super.finalize(...);
	}

	function init(num, options)
	{
		// num ̉Jo
		if(timer !== void) return; // łɉJ͂łĂ

		// J쐬
		for(var i = 0; i < num; i++)
		{
			var n = intrandom(0, 5); // J̑傫 ( _ )
			rains[i] = new RainGrain(window, n, this);
		}
		rains[0].spawn(); // ŏ̉J͍ŏ\

		// ^C}[쐬
		timer = new Timer(onTimer, '');
		timer.interval = 80;
		timer.enabled = true;

		foreVisible = true;
		backVisible = true;
		setOptions(options); // IvVݒ
	}

	function uninit()
	{
		// J
		if(timer === void) return; // J͂łĂȂ

		for(var i = 0; i < rains.count; i++)
			invalidate rains[i];
		rains.count = 0;

		invalidate timer;
		timer = void;
	}

	function setOptions(elm)
	{
		// IvVݒ肷
		foreVisible = +elm.forevisible if elm.forevisible !== void;
		backVisible = +elm.backvisible if elm.backvisible !== void;
		resetVisibleState();
	}

	function onTimer()
	{
		// ^C}[̎ƂɌĂ΂
		var raincount = rains.count;
		for(var i = 0; i < raincount; i++)
			rains[i].move(); // move \bhĂяo
	}

	function resetVisibleState()
	{
		// ׂẲJ \E\̏ԂĐݒ肷
		var raincount = rains.count;
		for(var i = 0; i < raincount; i++)
			rains[i].resetVisibleState(); // resetVisibleState \bhĂяo
	}

	function onStore(f, elm)
	{
		// xۑƂ
		var dic = f.rains = %[];
		dic.init = timer !== void;
		dic.foreVisible = foreVisible;
		dic.backVisible = backVisible;
		dic.rainCount = rains.count;
	}

	function onRestore(f, clear, elm)
	{
		// xǂݏoƂ
		var dic = f.rains;
		if(dic === void || !+dic.init)
		{
			// J͂łĂȂ
			uninit();
		}
		else if(dic !== void && +dic.init)
		{
			// J͂łĂ
			init(dic.rainCount, %[ forevisible : dic.foreVisible, backvisible : dic.backVisible ] );
		}
	}

	function onStableStateChanged(stable)
	{
	}

	function onMessageHiddenStateChanged(hidden)
	{
	}

	function onCopyLayer(toback)
	{
		// C̕\̃Rs[
		// ̃vOCł̓Rs[ׂ͕\E\̏񂾂
		if(toback)
		{
			// \
			backVisible = foreVisible;
		}
		else
		{
			// \
			foreVisible = backVisible;
		}
		resetVisibleState();
	}

	function onExchangeForeBack()
	{
		// ƕ\̊Ǘ
		var raincount = rains.count;
		for(var i = 0; i < raincount; i++)
			rains[i].exchangeForeBack(); // move \bhĂяo
	}
}

kag.addPlugin(global.rain_object = new RainPlugin(kag));
	// vOCIuWFNg쐬Ao^

@endscript
@endif
; }No^
@macro name="raininit"
@eval exp="rain_object.init(17, mp)"
@endmacro
@macro name="rainuninit"
@eval exp="rain_object.uninit()"
@endmacro
@macro name="rainopt"
@eval exp="rain_object.setOptions(mp)"
@endmacro
@return
